#ifndef BTree_hh
#define BTree_hh

//make sure you include the db_cxx for the c++ calls
#include "third_party/berkeleydb/db_cxx.h"

#include "Vocabulary.hh"
#include "Rule.hh"
#include "ParserInfo.hh"
#include "RuleSet.hh"

#include <vector>


class CBTree : public RuleSet {

public:

  //static CVocabulary* pVoc; //!static voc set at top level

  //!Initializes the DB and also loads in the _COUNT information
  CBTree(samtstring dbFileName);
  ~CBTree();

  // Query the B-tree for prefix and return result as described above
  // in definition of CBTreeResult
  virtual RuleQueryResult QueryRuleSet(const vector<CWordIndex>& prefix);
 protected:

  //!Utilty method to see exactly what got put into the db
  void PrintDB();
  // database object, needs to be a pointer cause there is no
  // default constructor
  Db* m_db;


};

#endif
