/*
  Syntax Based Statistical Machine Translation
  Chart Parsing Tool for Generalized, Annotated Synchronous Grammars
  Copyright (C) 2006  Andreas Zollmann, Ashish Venugopal
  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public License
  along with this program; if not, see <http://www.gnu.org/licenses/>.

*/

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif
#ifndef __BOOL_H
#define __BOOL_H


//--------------------------------------------------------------------
//
// Datatype BOOL for truth values
//
//--------------------------------------------------------------------

class BOOL {

public:

  BOOL( int = 0);
  operator int() const;

private:

  int m_Value;

}; // BOOL



//========================= Inlines =================================

inline BOOL::BOOL( int i ) {
  m_Value = i ? 1 : 0;
}


inline BOOL::operator int() const {
  return m_Value;
}



// GNU-Compiler has bool, other compilers get it here

#ifndef __GNUC__

typedef BOOL bool;

#endif


//========================= Constants ==============================

#ifdef FALSE
#undef FALSE
#endif
#ifdef TRUE
#undef TRUE
#endif
#ifdef False
#undef False
#endif
#ifdef True
#undef True
#endif


// for the GNU-Compiler
#ifdef __GNUC__

#define TRUE true
#define FALSE false

#define True true
#define False false

#endif // __GNUC__


// for the rest of the world
#ifndef __GNUC__

const BOOL FALSE(0);
const BOOL TRUE(1);

const BOOL False(0);
const BOOL True(1);

const BOOL false(0);
const BOOL true(1);

#endif // !__GNUC__


#endif
