/*
  Syntax Based Statistical Machine Translation
  Chart Parsing Tool for Generalized, Annotated Synchronous Grammars
  Copyright (C) 2006  Andreas Zollmann, Ashish Venugopal
  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public License
  along with this program; if not, see <http://www.gnu.org/licenses/>.

*/

//return a normalized version of the string
#include "Types.hh"
#include "pstream.h"
#include "samtstring.hh"
#include <iostream>



redi::pstream* pbuf_global;
bool pbuf_global_inited=false;

samtstring InitializePBUF(const char* NormalizingScript){
  cout<<"Open perl normalizing script:"<<NormalizingScript<<endl;
  //samtstringstream ssperl(stringstream::in | stringstream::out);
  //ssperl<<"perl "<<NormalizingScript;
  //string perlNormalizer = ssperl.str();
  pbuf_global = new redi::pstream();
  samtstring perlNormalizer = "perl " + samtstring(NormalizingScript);
  //cout<<"Line: "<<perlNormalizer<<endl;
  pbuf_global->open(perlNormalizer, std::ios_base::out | std::ios_base::in);
  //cout<<"Opened: "<<perlNormalizer<<endl;
  if (!pbuf_global->good()){
    cout<<"Unable to open normalizing script:"<<perlNormalizer<<endl;
    exit(-1);
  }
  cout<<"Initialization complete\n";
  pbuf_global_inited = true;

}

samtstring ClosePBUF(){
  if (pbuf_global->good()){
    pbuf_global->flush();
    cout<<"pbuf flushed\n";
    pbuf_global->close();
    cout<<"pbuf closed\n";
  }
}

samtstring NormalizeStringPBUF(samtstring inputString){
  //cout<<"inputString:"<<inputString<<endl;
  if (!pbuf_global_inited){
    //cout<<"not initialized"<<endl;
    return inputString;
  }
  if (pbuf_global->good()){
    *pbuf_global<<inputString<<"\n\r";
    pbuf_global->flush();
    
    samtstring str;
    //pbuf.getLine();
    std::getline(pbuf_global->out(), str);
    //cout<<"returnString:"<<str<<endl;
    return str;
  }else{
    //cout<<"not good"<<endl;
    return inputString;
  }
  //cout<<"never here"<<endl;
  return inputString;
}
