/*
  Syntax Based Statistical Machine Translation
  Chart Parsing Tool for Generalized, Annotated Synchronous Grammars
  Copyright (C) 2006  Andreas Zollmann, Ashish Venugopal
  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public License
  along with this program; if not, see <http://www.gnu.org/licenses/>.

*/

#ifndef __types__
#define __types__

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include "samtstring.hh"
#include <math.h>

//! n.o. characters maximum when reading in a line
#define MAXBUF 100000
//az: now a static variable in ParserInfo.hh: #define C_HistoryLength 2 //history length for the language model

typedef unsigned char    uchar;
typedef signed char      schar;
typedef unsigned short   ushort;
typedef unsigned int     uint;
typedef unsigned long    ulong;


#define MIN(a,b) (((a)<(b))?(a):(b))
#define MAX(a,b) (((a)>(b))?(a):(b))
#define SIGN(a) (((a)<(0))?(-1): (a==0)?(0):(+1))

//global text normalization
samtstring NormalizeStringPBUF(samtstring inputString);
samtstring InitializePBUF(const char* NormalizingScript);
samtstring ClosePBUF();

#endif
