/*
  Syntax Based Statistical Machine Translation
  Chart Parsing Tool for Generalized, Annotated Synchronous Grammars
  Copyright (C) 2006  Andreas Zollmann, Ashish Venugopal
  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public License
  along with this program; if not, see <http://www.gnu.org/licenses/>.

*/

/*
  Syntax Based Statistical Machine Translation
  Chart Parsing Tool for Generalized, Annotated Synchronous Grammars
  Copyright (C) 2006  Andreas Zollmann, Ashish Venugopal
  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public License
  along with this program; if not, see <http://www.gnu.org/licenses/>.

*/

#ifndef __utils_hh__
#define __utils_hh__
#ifdef HAVE_CONFIG_H
#include <config.h>
#endif
#include <fortify.h>

#include <stdlib.h>


#define EXIT_IF(C, M, V) {if (C) \
			 {cerr << endl << "ERROR: " << M << "... exiting" << endl; \
			    exit (V);}}

#define ABORT_IF(C, M) {if (C) \
			 {cerr << endl << "ERROR: " << M << "... aborting" << endl; \
			    abort();}}

#define RETURN_IF(C, M, V) {if (C) \
			 {cerr << endl << M  << endl; \
			    return (V);}}

#define MAX(E, A, B) {E = ((A) > (B)) ? (A) : (B);}
#define MIN(E, A, B) {E = ((A) < (B)) ? (A) : (B);}


#endif










